'' =================================================================================================
''
''   File....... jm_mm74C922_test_v3.spin
''   Purpose.... 
''   Author..... Jon "JonnyMac" McPhalen (aka Jon Williams)
''               Copyright (c) 2010 Jon McPhalen
''               -- see below for terms of use
''   E-mail..... jon@jonmcphalen.term
''   Started.... 
''   Updated.... 26 DEC 2010
''
'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal
' _xinfreq = 6_250_000                                          ' use 6.25MHz crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000


con

  RX1   = 31
  TX1   = 30
  SDA   = 29
  SCL   = 28

  K_RDY =  5                                                    ' data available
  K_MSB =  4                                                    ' E output
  K_LSB =  0                                                    ' A output


con 

  #1, HOME, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR, #16, CLS      ' PST formmatting control


obj

  kbd  : "jm_74c922" 
  term : "fullduplexserial"
  

var


pub main | n, k

  kbd.start(K_RDY, K_LSB)                                       ' start key buffering  
  term.start(RX1, TX1, %0000, 115_200)                          ' start terminal
  pause(1)

  term.tx(CLS)
  term.str(string("MM74C922 Test -- V3", CR, CR))

  repeat
    pause(1000)                                                 ' time to buffer keys
    n := kbd.bufsize
    if (n == 0)
      term.str(string("-- buffer empty", CR))
    else
      term.dec(n)
      term.str(string(" keys waiting:", CR))
      repeat n
        term.str(string("--> "))
        term.hex(kbd.getkey, 1)
        term.tx(CR)
      term.tx(CR)   

 
pub pause(ms) | t

'' Delay program ms milliseconds

  t := cnt - 1088                                               ' sync with system counter
  repeat (ms #> 0)                                              ' delay must be > 0
    waitcnt(t += MS_001)


dat

{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}